<?php
/*
  $Id: spu.php $

  v. 2.3
  by @raiwa info@oscaddons.com
  www.oscaddons.com

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License

*/

  class spu extends abstract_shipping_module {

    const CONFIG_KEY_BASE = 'MODULE_SHIPPING_SPU_';

// class methods
    public function quote($method = '') {
    	global $order;

      $error = false;

      $dept_allow = explode(',', MODULE_SHIPPING_SPU_ZIP);
    	$cust_cp = substr($order->delivery['postcode'], 0, strlen($dept_allow['0']));

    	if ( !in_array($cust_cp, $dept_allow) && MODULE_SHIPPING_SPU_ZIP != '' ) {
    	   $error = true;
    	}

      if ($error === false) {
        $this->quotes = [
          'id' => $this->code,
          'module' => MODULE_SHIPPING_SPU_TEXT_TITLE,
          'methods' => [[
            'id' => $this->code,
            'title' => MODULE_SHIPPING_SPU_TEXT_WAY,
            'cost' => $this->base_constant('COST'),
          ]],
        ];
      } else {
        $this->quotes = [
          'id' => $this->code,
          'module' => MODULE_SHIPPING_SPU_TEXT_TITLE,
          'methods' => [],
        ];
      }

      $this->quote_common();

      return $this->quotes;
    }

    protected function get_parameters() {
      return [
        $this->config_key_base . 'STATUS' => [
          'title' => 'Enable Store Pick Up',
          'value' => 'True',
          'desc' => 'Do you want to offer Store Pick Up shipping?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        $this->config_key_base . 'COST' => [
          'title' => 'Shipping Cost',
          'value' => '0.00',
          'desc' => 'The shipping cost for all orders using this shipping method.',
        ],
        $this->config_key_base . 'TAX_CLASS' => [
          'title' => 'Tax Class',
          'value' => '0',
          'desc' => 'Use the following tax class on the shipping fee.',
          'use_func' => 'Tax::get_class_title',
          'set_func' => 'Config::select_tax_class(',
        ],
        $this->config_key_base . 'ZONE' => [
          'title' => 'Shipping Zone',
          'value' => '0',
          'desc' => 'If a zone is selected, only enable this shipping method for that zone.',
          'use_func' => 'geo_zone::fetch_name',
          'set_func' => 'Config::select_geo_zone(',
        ],
        $this->config_key_base . 'ZIP' => [
          'title' => 'Store Pick Up Zip Code Allowed',
          'value' => '01,07,26,38,42,69,74',
          'desc' => 'Comma separated values. All entries must have the same amount of digits. Example: 07,58,69 or 256,589,789',
        ],
        $this->config_key_base . 'SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '0',
          'desc' => 'Sort order of display.',
        ],
      ];
    }

  }
